#This is the custom Quicksave-only implementation courtesy of JQuartz.  Domo Arigatou ^_^.
init:
    
    $ config.game_menu = [
            ( "return", u"Return", ui.jumps("_return"), 'True'),
            ( "skipping", u"Begin Skipping", ui.jumps("_return_skipping"), 'config.allow_skipping and not renpy.context().main_menu'),
            ( "prefs", u"Preferences", _intra_jumps("_prefs_screen", "intra_transition"), 'True' ),
            ( "save", u"Save Game", _intra_jumps("_JQuartz_custom_save_screen_which_was_made_after_hours_and_hours_toiling_in_front_of_the_monitor", "intra_transition"), 'not renpy.context().main_menu' ),
            ( "load", u"Load Game", _intra_jumps("_JQuartz_custom_load_screen_which_thankfully_was_easier_than_the_custom_save_screen", "intra_transition"), 'True'),
            ( "mainmenu", u"Main Menu", lambda : _mainmenu_prompt(), 'not renpy.context().main_menu' ),
            ( "quit", u"Quit", lambda : _quit_prompt("quit"), 'True' ),
            ]
    $ _game_menu_screen = "_JQuartz_custom_save_screen_which_was_made_after_hours_and_hours_toiling_in_front_of_the_monitor"
    $ config.main_menu = [
        ( u"Start Game", "start", 'True'),
        ( u"Continue Game", _intra_jumps("_JQuartz_custom_load_screen_which_thankfully_was_easier_than_the_custom_save_screen", "main_game_transition"), 'True' ),
        ( u"Preferences", _intra_jumps("_prefs_screen", "main_game_transition"), 'True' ),
        ( u"Quit",  ui.jumps("_quit"), 'True' ),
        ]
    $ JQuartz_xscreen = config.screen_width / 2.5
    $ JQuartz_yscreen = config.screen_height / 1.5
    $ JQuartz_xbar = config.screen_width / 2.5
   
#######OVERLAY HERE######################################################    
    
init python:
        
        def toggle_skipping():
            config.skipping = not config.skipping
        def quicks_overlay():
            if not game_had_started:
                return
            elif game_had_started:
                ui.hbox(xpos=0.3, ypos=0, xanchor='left', yanchor=0)
                ui.textbutton("Q Save",clicked=renpy.curried_call_in_new_context('_JQuartz_quick_saves'), xminimum=80)
                ui.textbutton("Q Load",clicked=renpy.curried_call_in_new_context('_JQuartz_quick_loads'), xminimum=80)
                ui.textbutton("Prefs", clicked=renpy.curried_call_in_new_context("_game_menu_preferences"), xminimum=80)
                ui.textbutton("Skip", clicked=toggle_skipping, xminimum=80)
                ui.close()
        config.overlay_functions.append(quicks_overlay) 
            
######OVERLAY HERE#######################################################    
    

                  
    
    
label _JQuartz_custom_save_screen_which_was_made_after_hours_and_hours_toiling_in_front_of_the_monitor:
    $ _game_nav("save") 
        
    python:         
        JQuartz_value = renpy.scan_saved_game("JQuartz")
        ## edit this to change the position
        ui.vbox(xpos= 0, ypos=0.01, xmaximum=config.screen_width)
        ui.frame()
        ui.vbox()
        if JQuartz_value:
            ui.button(style=style.file_picker_entry, clicked=None )
            JQuartz_sv = config.file_entry_format % dict(
            time=renpy.time.strftime(config.time_format,
                                     renpy.time.localtime(JQuartz_value[2])),
            save_name=JQuartz_value[0])
        elif not JQuartz_value:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = "No Save File"
        ui.hbox()
        if JQuartz_value:
            if not config.disable_thumbnails:
                ui.add(JQuartz_value[1])
        elif not JQuartz_value or config.disable_thumbnails:
            ui.null(height=50, width = 66)
        ui.vbox()
        ui.text("Quick Save" + ". ", style=style.file_picker_old)
        ui.text(JQuartz_sv, style=style.file_picker_extra_info)
        ui.close()
        ui.close()
        
        JQuartz_value2 = renpy.scan_saved_game("JQuartz2")
        if JQuartz_value2:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = config.file_entry_format % dict(
            time=renpy.time.strftime(config.time_format,
                                     renpy.time.localtime(JQuartz_value2[2])),
            save_name=JQuartz_value2[0])
        elif not JQuartz_value2:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = "No Save File"
        ui.hbox()
        if JQuartz_value2:
            if not config.disable_thumbnails:
                ui.add(JQuartz_value2[1])
        elif not JQuartz_value2 or config.disable_thumbnails:
            ui.null(height=50, width = 66)
        ui.vbox()
        ui.text("Quick Save" + ". ", style=style.file_picker_old)
        ui.text(JQuartz_sv, style=style.file_picker_extra_info)
        ui.close()
        ui.close()
        
        JQuartz_value3 = renpy.scan_saved_game("JQuartz3")
        if JQuartz_value3:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = config.file_entry_format % dict(
            time=renpy.time.strftime(config.time_format,
                                     renpy.time.localtime(JQuartz_value3[2])),
            save_name=JQuartz_value3[0])
        elif not JQuartz_value3:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = "No Save File"
        ui.hbox()
        if JQuartz_value3:
            if not config.disable_thumbnails:
                ui.add(JQuartz_value3[1])
        elif not JQuartz_value3 or config.disable_thumbnails:
            ui.null(height=50, width = 66)
        ui.vbox()
        ui.text("Quick Save" + ". ", style=style.file_picker_old)
        ui.text(JQuartz_sv, style=style.file_picker_extra_info)
        ui.close()
        ui.close()
        
        ui.close()
        ui.close()
        
      
    $ JQuartz_fn = _game_interact()


    jump _JQuartz_custom_save_screen_which_was_made_after_hours_and_hours_toiling_in_front_of_the_monitor
                  
  
    
label _JQuartz_custom_load_screen_which_thankfully_was_easier_than_the_custom_save_screen:
    $ _game_nav("load") 
    
    
    
    python:
        JQuartz_value = renpy.scan_saved_game("JQuartz")
        ## edit this to change the position
        ui.vbox(xpos= 0, ypos=0.01, xmaximum=config.screen_width)
        ui.frame()
        ui.vbox()
        if JQuartz_value:
            ui.button(style=style.file_picker_entry, clicked=ui.returns("JQuartz"))
            JQuartz_sv = config.file_entry_format % dict(
            time=renpy.time.strftime(config.time_format,
                                     renpy.time.localtime(JQuartz_value[2])),
            save_name=JQuartz_value[0])
        elif not JQuartz_value:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = "No Save File"
        ui.hbox()
        if JQuartz_value:
            if not config.disable_thumbnails:
                ui.add(JQuartz_value[1])
        elif not JQuartz_value or config.disable_thumbnails:
            ui.null(height=50, width = 66)
        ui.vbox()
        ui.text("Quick Save" + ". ", style=style.file_picker_old)
        ui.text(JQuartz_sv, style=style.file_picker_extra_info)
        ui.close()
        ui.close()

        
        JQuartz_value2 = renpy.scan_saved_game("JQuartz2")
        if JQuartz_value2:
            ui.button(style=style.file_picker_entry, clicked=ui.returns("JQuartz2"))
            JQuartz_sv = config.file_entry_format % dict(
            time=renpy.time.strftime(config.time_format,
                                     renpy.time.localtime(JQuartz_value2[2])),
            save_name=JQuartz_value2[0])
        elif not JQuartz_value2:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = "No Save File"
        ui.hbox()
        if JQuartz_value2:
            if not config.disable_thumbnails:
                ui.add(JQuartz_value2[1])
        elif not JQuartz_value2 or config.disable_thumbnails:
            ui.null(height=50, width = 66)
        ui.vbox()
        ui.text("Quick Save" + ". ", style=style.file_picker_old)
        ui.text(JQuartz_sv, style=style.file_picker_extra_info)
        ui.close()
        ui.close()
        
        JQuartz_value3 = renpy.scan_saved_game("JQuartz3")
        if JQuartz_value3:
            ui.button(style=style.file_picker_entry, clicked=ui.returns("JQuartz3"))
            JQuartz_sv = config.file_entry_format % dict(
            time=renpy.time.strftime(config.time_format,
                                     renpy.time.localtime(JQuartz_value3[2])),
            save_name=JQuartz_value3[0])
        elif not JQuartz_value3:
            ui.button(style=style.file_picker_entry, clicked=None)
            JQuartz_sv = "No Save File"
        ui.hbox()
        if JQuartz_value3:
            if not config.disable_thumbnails:
                ui.add(JQuartz_value3[1])
        elif not JQuartz_value3 or config.disable_thumbnails:
            ui.null(height=50, width = 66)
        ui.vbox()
        ui.text("Quick Save" + ". ", style=style.file_picker_old)
        ui.text(JQuartz_sv, style=style.file_picker_extra_info)
        ui.close()
        ui.close()
        ui.close()
        ui.close()
    
    $ JQuartz_fn = _game_interact()
    
    python:
              
        if not renpy.context().main_menu and _load_prompt:
            if _yesno_prompt("load", u"Loading will lose unsaved progress.\nAre you sure you want to do this?"):
                renpy.load(JQuartz_fn)
        else:                        
            renpy.load(JQuartz_fn)
    
    jump _JQuartz_custom_load_screen_which_thankfully_was_easier_than_the_custom_save_screen


label _JQuartz_quick_saves:
    python:
        if renpy.can_load("JQuartz3") :
            ui.frame(style='yesno_frame')
            ui.vbox(style='yesno_frame_vbox')

            _label_factory(u"Are you sure you want to overwrite your save?", "yesno")

            ui.hbox(style='yesno_button_hbox')
        
        
            _button_factory(u"Yes", 'yesno', clicked=ui.returns(True))
            _button_factory(u"No", 'yesno', clicked=ui.returns(False))

            ui.close()
            ui.close()
            JQuartz_savable=ui.interact(suppress_overlay=True,suppress_underlay=True)
            if JQuartz_savable:
                renpy.rename_save("JQuartz2", "JQuartz3") 
                renpy.rename_save("JQuartz", "JQuartz2") 
                renpy.save("JQuartz", save_name)
                ui.frame( xpos=0.5, ypos =0.5,xanchor= 0.5)
                ui.text('Game Saved')
                renpy.pause(0.5)      
        elif renpy.can_load("JQuartz2") :
            renpy.rename_save("JQuartz2", "JQuartz3")
            renpy.rename_save("JQuartz", "JQuartz2") 
            renpy.save("JQuartz", save_name)
            ui.frame( xpos=0.5, ypos =0.5,xanchor= 0.5)
            ui.text('Game Saved')
            renpy.pause(0.5)
        elif renpy.can_load("JQuartz") :
            renpy.rename_save("JQuartz", "JQuartz2") 
            renpy.save("JQuartz", save_name)
            ui.frame( xpos=0.5, ypos =0.5,xanchor= 0.5)
            ui.text('Game Saved')
            renpy.pause(0.5)
        else:
            renpy.save("JQuartz", save_name)
            ui.frame( xpos=0.5, ypos =0.5,xanchor= 0.5)
            ui.text('Game Saved')
            renpy.pause(0.5)    
            try:
                renpy.save("JQuartz", save_name)
                ui.frame( xpos=0.5, ypos =0.5,xanchor= 0.5)
                ui.text('Game Saved')
                renpy.pause(0.5)
            except Exception, e:

                if config.debug:
                    raise
                
                JQuartz_messege = u"You may want to try saving in a different slot, or playing for a while and trying again later."

                _show_exception(_(u"Save Failed."), JQuartz_messege)
        
            
    return

label _JQuartz_quick_loads:
    python:
        if renpy.can_load("JQuartz") :
            ui.frame(style='yesno_frame')
            ui.vbox(style='yesno_frame_vbox')

            _label_factory(u"Loading will lose unsaved progress.\nAre you sure you want to do this?", "yesno")

            ui.hbox(style='yesno_button_hbox')
        
        
            _button_factory(u"Yes", 'yesno', clicked=ui.returns(True))
            _button_factory(u"No", 'yesno', clicked=ui.returns(False))

            ui.close()
            ui.close()
            JQuartz_savable=ui.interact(suppress_overlay=True,suppress_underlay=True)
            if JQuartz_savable:
                renpy.load("JQuartz")
        
    return
        
